diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
index 77a5162ef..eaeb793e3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
@@ -2,7 +2,7 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightingCache;
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.TessellatorTerrain;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
@@ -14,12 +14,10 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
 import static net.minecraft.client.render.block.model.BlockModel.FULL_CUBE_THRESHOLD;
-import static net.minecraft.client.render.block.model.BlockModel.SIDE_LIGHT_MULTIPLIER;
 
 public final class RenderBlocks {
     public final Minecraft mc;
@@ -51,7 +49,6 @@ public final class RenderBlocks {
     public int lightmapCoordBottomLeft;
     public int lightmapCoordBottomRight;
     public int lightmapCoordTopRight;
-    public boolean overbright;
     public LightingCache cache = new LightingCache();
 
     public RenderBlocks() {
@@ -111,11 +108,11 @@ public final class RenderBlocks {
     }
 
     @Deprecated
-    public boolean renderStandardBlock(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, int x, int y, int z) {
+    public boolean renderStandardBlock(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, int x, int y, int z) {
         return renderStandardBlock(tessellator, worldSource, blockModel, bounds, new TilePos(x, y, z));
     }
 
-    public boolean renderStandardBlock(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, @NotNull TilePosc tilePos) {
+    public boolean renderStandardBlock(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, @NotNull TilePosc tilePos) {
         int color = BlockColorDispatcher.getInstance().getDispatch(blockModel.block).getWorldColor(worldSource, tilePos, 0);
         float r = (float) (color >> 16 & 0xff) / 255F;
         float g = (float) (color >> 8 & 0xff) / 255F;
@@ -128,11 +125,11 @@ public final class RenderBlocks {
      * Thanks! :D
      */
     @Deprecated
-    public boolean renderStandardBlock(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, int x, int y, int z, float r, float g, float b) {
+    public boolean renderStandardBlock(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, int x, int y, int z, float r, float g, float b) {
         return renderStandardBlock(tessellator, worldSource, blockModel, bounds, new TilePos(x, y, z), r, g, b);
     }
 
-    public boolean renderStandardBlock(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, float r, float g, float b) {
+    public boolean renderStandardBlock(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, float r, float g, float b) {
         this.enableAO = true;
         int meta = worldSource.getBlockData(tilePos);
         this.cache.setupCache(blockModel.block, worldSource, tilePos);
@@ -145,11 +142,11 @@ public final class RenderBlocks {
     }
 
     @Deprecated
-    public boolean renderSide(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, int x, int y, int z, float r, float g, float b, @NotNull Side side, int meta) {
+    public boolean renderSide(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, int x, int y, int z, float r, float g, float b, @NotNull Side side, int meta) {
         return renderSide(tessellator, worldSource, blockModel, bounds, new TilePos(x, y, z), r, g, b, side, meta);
     }
 
-    public boolean renderSide(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, float r, float g, float b, @NotNull Side side, int meta) {
+    public boolean renderSide(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, float r, float g, float b, @NotNull Side side, int meta) {
         boolean useColor;
         return switch (side) {
             case BOTTOM -> {
@@ -208,18 +205,13 @@ public final class RenderBlocks {
      * @author CyborgCabbage
      * Thanks! :D
      */
-    public boolean renderSide(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds,
+    public boolean renderSide(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds,
                               @NotNull TilePosc tilePos, float r, float g, float b, @NotNull Side side, int meta,
                               int dirX, int dirY, int dirZ, float depth,
                               int topX, int topY, int topZ, float topP, float botP,
                               int lefX, int lefY, int lefZ, float lefP, float rigP
     ) {
-        IconCoordinate tex;
-        if (this.overbright) {
-            tex = blockModel.getBlockOverbrightTexture(worldSource, tilePos, side);
-        } else {
-            tex = blockModel.getBlockTexture(worldSource, tilePos, side);
-        }
+        IconCoordinate tex = blockModel.getBlockTexture(worldSource, tilePos, side);
         if (tex == null || ((this.renderBitMask >> side.getId()) & 1) != 0) return false;
 
         boolean rendered = false;
@@ -262,7 +254,7 @@ public final class RenderBlocks {
         boolean ao = this.mc.isAmbientOcclusionEnabled() && block.emission == 0;
         boolean isFullCube = depth <= FULL_CUBE_THRESHOLD;
 
-        if (this.overbright) {
+        if (ao) {
             int dirX2 = dirX;
             int dirY2 = dirY;
             int dirZ2 = dirZ;
@@ -273,56 +265,40 @@ public final class RenderBlocks {
                 dirZ2 = 0;
             }
 
-            int lmc = LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, dirX2, dirY2, dirZ2));
+            boolean topT = this.cache.getOpacity(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
+            boolean botT = this.cache.getOpacity(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
+            boolean lefT = this.cache.getOpacity(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
+            boolean rigT = this.cache.getOpacity(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
 
-            this.lightmapCoordTopLeft = this.lightmapCoordBottomLeft = this.lightmapCoordBottomRight = this.lightmapCoordTopRight = lmc;
+            boolean topLefT = this.cache.getOpacity(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ);
+            boolean topRigT = this.cache.getOpacity(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ);
+            boolean botLefT = this.cache.getOpacity(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ);
+            boolean botRigT = this.cache.getOpacity(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ);
+
+            int lmcCen = this.cache.getLightmapCoord(dirX2, dirY2, dirZ2);
+
+            int lmcTop = topT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
+            int lmcBot = botT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
+            int lmcLef = lefT ? lmcCen : this.cache.getLightmapCoord(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
+            int lmcRig = rigT ? lmcCen : this.cache.getLightmapCoord(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
+
+            int lmcTopLef = topT && lefT ? lmcLef : (topLefT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ));
+            int lmcBotLef = botT && lefT ? lmcLef : (botLefT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ));
+            int lmcTopRig = topT && rigT ? lmcRig : (topRigT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ));
+            int lmcBotRig = botT && rigT ? lmcRig : (botRigT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ));
+
+            this.lightmapCoordTopLeft = LightmapHelper.avg(lmcCen, lmcLef, lmcTop, lmcTopLef);
+            this.lightmapCoordTopRight = LightmapHelper.avg(lmcCen, lmcRig, lmcTop, lmcTopRig);
+            this.lightmapCoordBottomLeft = LightmapHelper.avg(lmcCen, lmcLef, lmcBot, lmcBotLef);
+            this.lightmapCoordBottomRight = LightmapHelper.avg(lmcCen, lmcRig, lmcBot, lmcBotRig);
         } else {
-            if (ao) {
-                int dirX2 = dirX;
-                int dirY2 = dirY;
-                int dirZ2 = dirZ;
-
-                if (!isFullCube) {
-                    dirX2 = 0;
-                    dirY2 = 0;
-                    dirZ2 = 0;
-                }
-
-                boolean topT = this.cache.getOpacity(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
-                boolean botT = this.cache.getOpacity(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
-                boolean lefT = this.cache.getOpacity(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
-                boolean rigT = this.cache.getOpacity(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
-
-                boolean topLefT = this.cache.getOpacity(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ);
-                boolean topRigT = this.cache.getOpacity(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ);
-                boolean botLefT = this.cache.getOpacity(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ);
-                boolean botRigT = this.cache.getOpacity(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ);
-
-                int lmcCen = this.cache.getLightmapCoord(dirX2, dirY2, dirZ2);
-
-                int lmcTop = topT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
-                int lmcBot = botT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
-                int lmcLef = lefT ? lmcCen : this.cache.getLightmapCoord(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
-                int lmcRig = rigT ? lmcCen : this.cache.getLightmapCoord(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
-
-                int lmcTopLef = topT && lefT ? lmcLef : (topLefT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ));
-                int lmcBotLef = botT && lefT ? lmcLef : (botLefT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ));
-                int lmcTopRig = topT && rigT ? lmcRig : (topRigT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ));
-                int lmcBotRig = botT && rigT ? lmcRig : (botRigT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ));
-
-                this.lightmapCoordTopLeft = LightmapHelper.avg(lmcCen, lmcLef, lmcTop, lmcTopLef);
-                this.lightmapCoordTopRight = LightmapHelper.avg(lmcCen, lmcRig, lmcTop, lmcTopRig);
-                this.lightmapCoordBottomLeft = LightmapHelper.avg(lmcCen, lmcLef, lmcBot, lmcBotLef);
-                this.lightmapCoordBottomRight = LightmapHelper.avg(lmcCen, lmcRig, lmcBot, lmcBotRig);
+            int lmc;
+            if (!isFullCube) {
+                lmc = block.getLightmapCoord(worldSource, tilePos);
             } else {
-                int lmc;
-                if (!isFullCube) {
-                    lmc = block.getLightmapCoord(worldSource, tilePos);
-                } else {
-                    lmc = block.getLightmapCoord(worldSource, tilePos.add(dirX, dirY, dirZ, new TilePos()));
-                }
-                this.lightmapCoordTopLeft = this.lightmapCoordBottomLeft = this.lightmapCoordBottomRight = this.lightmapCoordTopRight = lmc;
+                lmc = block.getLightmapCoord(worldSource, tilePos.add(dirX, dirY, dirZ, new TilePos()));
             }
+            this.lightmapCoordTopLeft = this.lightmapCoordBottomLeft = this.lightmapCoordBottomRight = this.lightmapCoordTopRight = lmc;
         }
 
         float lightTR;
@@ -330,76 +306,63 @@ public final class RenderBlocks {
         float lightBL;
         float lightTL;
 
-        if (this.overbright) {
-            lightTR = 1.0F;
-            lightBR = 1.0F;
-            lightBL = 1.0F;
-            lightTL = 1.0F;
+        if (ao) {
+            {
+                float dirB = this.cache.getBrightness(dirX, dirY, dirZ);
+                boolean lefT = this.cache.getOpacity(dirX + lefX, dirY + lefY, dirZ + lefZ);
+                boolean botT = this.cache.getOpacity(dirX - topX, dirY - topY, dirZ - topZ);
+                boolean topT = this.cache.getOpacity(dirX + topX, dirY + topY, dirZ + topZ);
+                boolean rigT = this.cache.getOpacity(dirX - lefX, dirY - lefY, dirZ - lefZ);
+                float lB = this.cache.getBrightness(dirX + lefX, dirY + lefY, dirZ + lefZ);
+                float bB = this.cache.getBrightness(dirX - topX, dirY - topY, dirZ - topZ);
+                float tB = this.cache.getBrightness(dirX + topX, dirY + topY, dirZ + topZ);
+                float rB = this.cache.getBrightness(dirX - lefX, dirY - lefY, dirZ - lefZ);
+                float blB = botT && lefT ? lB : this.cache.getBrightness(dirX + lefX - topX, dirY + lefY - topY, dirZ + lefZ - topZ);
+                float tlB = topT && lefT ? lB : this.cache.getBrightness(dirX + lefX + topX, dirY + lefY + topY, dirZ + lefZ + topZ);
+                float brB = botT && rigT ? rB : this.cache.getBrightness(dirX - lefX - topX, dirY - lefY - topY, dirZ - lefZ - topZ);
+                float trB = topT && rigT ? rB : this.cache.getBrightness(dirX - lefX + topX, dirY - lefY + topY, dirZ - lefZ + topZ);
+                lightTL = (tlB + lB + tB + dirB) / 4.0F;
+                lightTR = (tB + dirB + trB + rB) / 4.0F;
+                lightBR = (dirB + bB + rB + brB) / 4.0F;
+                lightBL = (lB + blB + dirB + bB) / 4.0F;
+            }
+            if (!isFullCube) {
+                float dirB = this.cache.getBrightness(0, 0, 0);
+                boolean lefT = this.cache.getOpacity(lefX, lefY, lefZ);
+                boolean botT = this.cache.getOpacity(-topX, -topY, -topZ);
+                boolean topT = this.cache.getOpacity(topX, topY, topZ);
+                boolean rigT = this.cache.getOpacity(-lefX, -lefY, -lefZ);
+                float lB = this.cache.getBrightness(lefX, lefY, lefZ);
+                float bB = this.cache.getBrightness(-topX, -topY, -topZ);
+                float tB = this.cache.getBrightness(topX, topY, topZ);
+                float rB = this.cache.getBrightness(-lefX, -lefY, -lefZ);
+                float blB = botT && lefT ? lB : this.cache.getBrightness(lefX - topX, lefY - topY, lefZ - topZ);
+                float tlB = topT && lefT ? lB : this.cache.getBrightness(lefX + topX, lefY + topY, lefZ + topZ);
+                float brB = botT && rigT ? rB : this.cache.getBrightness(-lefX - topX, -lefY - topY, -lefZ - topZ);
+                float trB = topT && rigT ? rB : this.cache.getBrightness(-lefX + topX, -lefY + topY, -lefZ + topZ);
+                lightTL = (tlB + lB + tB + dirB) / 4.0F * depth + lightTL * (1 - depth);
+                lightTR = (tB + dirB + trB + rB) / 4.0F * depth + lightTR * (1 - depth);
+                lightBR = (dirB + bB + rB + brB) / 4.0F * depth + lightBR * (1 - depth);
+                lightBL = (lB + blB + dirB + bB) / 4.0F * depth + lightBL * (1 - depth);
+            }
         } else {
-            if (ao) {
-                {
-                    float dirB = this.cache.getBrightness(dirX, dirY, dirZ);
-                    boolean lefT = this.cache.getOpacity(dirX + lefX, dirY + lefY, dirZ + lefZ);
-                    boolean botT = this.cache.getOpacity(dirX - topX, dirY - topY, dirZ - topZ);
-                    boolean topT = this.cache.getOpacity(dirX + topX, dirY + topY, dirZ + topZ);
-                    boolean rigT = this.cache.getOpacity(dirX - lefX, dirY - lefY, dirZ - lefZ);
-                    float lB = this.cache.getBrightness(dirX + lefX, dirY + lefY, dirZ + lefZ);
-                    float bB = this.cache.getBrightness(dirX - topX, dirY - topY, dirZ - topZ);
-                    float tB = this.cache.getBrightness(dirX + topX, dirY + topY, dirZ + topZ);
-                    float rB = this.cache.getBrightness(dirX - lefX, dirY - lefY, dirZ - lefZ);
-                    float blB = botT && lefT ? lB : this.cache.getBrightness(dirX + lefX - topX, dirY + lefY - topY, dirZ + lefZ - topZ);
-                    float tlB = topT && lefT ? lB : this.cache.getBrightness(dirX + lefX + topX, dirY + lefY + topY, dirZ + lefZ + topZ);
-                    float brB = botT && rigT ? rB : this.cache.getBrightness(dirX - lefX - topX, dirY - lefY - topY, dirZ - lefZ - topZ);
-                    float trB = topT && rigT ? rB : this.cache.getBrightness(dirX - lefX + topX, dirY - lefY + topY, dirZ - lefZ + topZ);
-                    lightTL = (tlB + lB + tB + dirB) / 4.0F;
-                    lightTR = (tB + dirB + trB + rB) / 4.0F;
-                    lightBR = (dirB + bB + rB + brB) / 4.0F;
-                    lightBL = (lB + blB + dirB + bB) / 4.0F;
-                }
-                if (!isFullCube) {
-                    float dirB = this.cache.getBrightness(0, 0, 0);
-                    boolean lefT = this.cache.getOpacity(lefX, lefY, lefZ);
-                    boolean botT = this.cache.getOpacity(-topX, -topY, -topZ);
-                    boolean topT = this.cache.getOpacity(topX, topY, topZ);
-                    boolean rigT = this.cache.getOpacity(-lefX, -lefY, -lefZ);
-                    float lB = this.cache.getBrightness(lefX, lefY, lefZ);
-                    float bB = this.cache.getBrightness(-topX, -topY, -topZ);
-                    float tB = this.cache.getBrightness(topX, topY, topZ);
-                    float rB = this.cache.getBrightness(-lefX, -lefY, -lefZ);
-                    float blB = botT && lefT ? lB : this.cache.getBrightness(lefX - topX, lefY - topY, lefZ - topZ);
-                    float tlB = topT && lefT ? lB : this.cache.getBrightness(lefX + topX, lefY + topY, lefZ + topZ);
-                    float brB = botT && rigT ? rB : this.cache.getBrightness(-lefX - topX, -lefY - topY, -lefZ - topZ);
-                    float trB = topT && rigT ? rB : this.cache.getBrightness(-lefX + topX, -lefY + topY, -lefZ + topZ);
-                    lightTL = (tlB + lB + tB + dirB) / 4.0F * depth + lightTL * (1 - depth);
-                    lightTR = (tB + dirB + trB + rB) / 4.0F * depth + lightTR * (1 - depth);
-                    lightBR = (dirB + bB + rB + brB) / 4.0F * depth + lightBR * (1 - depth);
-                    lightBL = (lB + blB + dirB + bB) / 4.0F * depth + lightBL * (1 - depth);
-                }
-            } else {
-                int dirX2 = dirX;
-                int dirY2 = dirY;
-                int dirZ2 = dirZ;
-
-                if (!isFullCube) {
-                    dirX2 = 0;
-                    dirY2 = 0;
-                    dirZ2 = 0;
-                }
-
-                float brightness = this.cache.getBrightness(dirX2, dirY2, dirZ2);
-                lightTL = lightBL = lightBR = lightTR = brightness;
+            int dirX2 = dirX;
+            int dirY2 = dirY;
+            int dirZ2 = dirZ;
+
+            if (!isFullCube) {
+                dirX2 = 0;
+                dirY2 = 0;
+                dirZ2 = 0;
             }
-        }
 
-        if (this.overbright || !BlockModel.ENABLE_DIRECTIONAL_LIGHTING) {
-            this.colorRedTopLeft = this.colorRedBottomLeft = this.colorRedBottomRight = this.colorRedTopRight = r;
-            this.colorGreenTopLeft = this.colorGreenBottomLeft = this.colorGreenBottomRight = this.colorGreenTopRight = g;
-            this.colorBlueTopLeft = this.colorBlueBottomLeft = this.colorBlueBottomRight = this.colorBlueTopRight = b;
-        } else {
-            this.colorRedTopLeft = this.colorRedBottomLeft = this.colorRedBottomRight = this.colorRedTopRight = r * SIDE_LIGHT_MULTIPLIER[side.getId()];
-            this.colorGreenTopLeft = this.colorGreenBottomLeft = this.colorGreenBottomRight = this.colorGreenTopRight = g * SIDE_LIGHT_MULTIPLIER[side.getId()];
-            this.colorBlueTopLeft = this.colorBlueBottomLeft = this.colorBlueBottomRight = this.colorBlueTopRight = b * SIDE_LIGHT_MULTIPLIER[side.getId()];
+            float brightness = this.cache.getBrightness(dirX2, dirY2, dirZ2);
+            lightTL = lightBL = lightBR = lightTR = brightness;
         }
+
+        this.colorRedTopLeft = this.colorRedBottomLeft = this.colorRedBottomRight = this.colorRedTopRight = r;
+        this.colorGreenTopLeft = this.colorGreenBottomLeft = this.colorGreenBottomRight = this.colorGreenTopRight = g;
+        this.colorBlueTopLeft = this.colorBlueBottomLeft = this.colorBlueBottomRight = this.colorBlueTopRight = b;
         float tl = topP * lightTL + (1 - topP) * lightBL;
         float tr = topP * lightTR + (1 - topP) * lightBR;
         float bl = botP * lightTL + (1 - botP) * lightBL;
@@ -425,11 +388,11 @@ public final class RenderBlocks {
         this.colorBlueTopRight *= ltr;
     }
 
-    public void renderBottomFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
+    public void renderBottomFace(@NotNull TessellatorGeneral tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
         renderBottomFace(tessellator, bounds, tilePos.x(), tilePos.y(), tilePos.z(), tex);
     }
 
-    public void renderBottomFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
+    public void renderBottomFace(@NotNull TessellatorGeneral tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
         if (this.overrideBlockTexture != null) tex = this.overrideBlockTexture;
         if (tex == null) return;
         double d3 = tex.getSubIconU(bounds.minX());
@@ -485,6 +448,7 @@ public final class RenderBlocks {
         double d13 = y + bounds.minY();
         double d14 = z + bounds.minZ();
         double d15 = z + bounds.maxZ();
+        tessellator.setNormal(0, -1, 0);
         if (this.enableAO) {
             tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
             tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
@@ -504,13 +468,14 @@ public final class RenderBlocks {
             tessellator.addVertexWithUV(d12, d13, d14, d7, d9);
             tessellator.addVertexWithUV(d12, d13, d15, d4, d6);
         }
+        tessellator.setNormal(0, 1, 0);
     }
 
-    public void renderTopFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
+    public void renderTopFace(@NotNull TessellatorGeneral tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
         renderTopFace(tessellator, bounds, tilePos.x(), tilePos.y(), tilePos.z(), tex);
     }
 
-    public void renderTopFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
+    public void renderTopFace(@NotNull TessellatorGeneral tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
         if (this.overrideBlockTexture != null) tex = this.overrideBlockTexture;
         if (tex == null) return;
         double d3 = tex.getSubIconU(bounds.minX());
@@ -566,6 +531,7 @@ public final class RenderBlocks {
         double d13 = y + bounds.maxY();
         double d14 = z + bounds.minZ();
         double d15 = z + bounds.maxZ();
+        tessellator.setNormal(0, 1, 0);
         if (this.enableAO) {
             tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
             tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
@@ -585,13 +551,14 @@ public final class RenderBlocks {
             tessellator.addVertexWithUV(d11, d13, d14, d3, d5);
             tessellator.addVertexWithUV(d11, d13, d15, d8, d10);
         }
+        tessellator.setNormal(0, 1, 0);
     }
 
-    public void renderNorthFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
+    public void renderNorthFace(@NotNull TessellatorGeneral tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
         renderNorthFace(tessellator, bounds, tilePos.x(), tilePos.y(), tilePos.z(), tex);
     }
 
-    public void renderNorthFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
+    public void renderNorthFace(@NotNull TessellatorGeneral tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
         if (this.overrideBlockTexture != null) tex = this.overrideBlockTexture;
         if (tex == null) return;
         double d3 = tex.getSubIconU(bounds.minX());
@@ -652,6 +619,7 @@ public final class RenderBlocks {
         double d14 = y + bounds.minY();
         double d15 = y + bounds.maxY();
         double d16 = z + bounds.minZ();
+        tessellator.setNormal(0, 0, -1);
         if (this.enableAO) {
             tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
             tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
@@ -671,13 +639,14 @@ public final class RenderBlocks {
             tessellator.addVertexWithUV(d13, d14, d16, d9, d11);
             tessellator.addVertexWithUV(d12, d14, d16, d4, d6);
         }
+        tessellator.setNormal(0, 1, 0);
     }
 
-    public void renderSouthFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
+    public void renderSouthFace(@NotNull TessellatorGeneral tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
         renderSouthFace(tessellator, bounds, tilePos.x(), tilePos.y(), tilePos.z(), tex);
     }
 
-    public void renderSouthFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
+    public void renderSouthFace(@NotNull TessellatorGeneral tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
         if (this.overrideBlockTexture != null) tex = this.overrideBlockTexture;
         if (tex == null) return;
         double d3 = tex.getSubIconU(bounds.minX());
@@ -738,6 +707,7 @@ public final class RenderBlocks {
         double y0 = y + bounds.minY();
         double y1 = y + bounds.maxY();
         double z0 = z + bounds.maxZ();
+        tessellator.setNormal(0, 0, 1);
         if (this.enableAO) {
             tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
             tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
@@ -757,13 +727,14 @@ public final class RenderBlocks {
             tessellator.addVertexWithUV(x1, y0, z0, d4, d6);
             tessellator.addVertexWithUV(x1, y1, z0, d8, d10);
         }
+        tessellator.setNormal(0, 1, 0);
     }
 
-    public void renderWestFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
+    public void renderWestFace(@NotNull TessellatorGeneral tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
         renderWestFace(tessellator, bounds, tilePos.x(), tilePos.y(), tilePos.z(), tex);
     }
 
-    public void renderWestFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
+    public void renderWestFace(@NotNull TessellatorGeneral tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
         if (this.overrideBlockTexture != null) tex = this.overrideBlockTexture;
         if (tex == null) return;
         double d3 = tex.getSubIconU(bounds.minZ());
@@ -824,6 +795,7 @@ public final class RenderBlocks {
         double d14 = y + bounds.maxY();
         double d15 = z + bounds.minZ();
         double d16 = z + bounds.maxZ();
+        tessellator.setNormal(-1, 0, 0);
         if (this.enableAO) {
             tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
             tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
@@ -843,13 +815,14 @@ public final class RenderBlocks {
             tessellator.addVertexWithUV(d12, d13, d15, d9, d11);
             tessellator.addVertexWithUV(d12, d13, d16, d4, d6);
         }
+        tessellator.setNormal(0, 1, 0);
     }
 
-    public void renderEastFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
+    public void renderEastFace(@NotNull TessellatorGeneral tessellator, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @Nullable IconCoordinate tex) {
         renderEastFace(tessellator, bounds, tilePos.x(), tilePos.y(), tilePos.z(), tex);
     }
 
-    public void renderEastFace(@NotNull TessellatorTerrain tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
+    public void renderEastFace(@NotNull TessellatorGeneral tessellator, @NotNull AABBdc bounds, double x, double y, double z, @Nullable IconCoordinate tex) {
         if (this.overrideBlockTexture != null) tex = this.overrideBlockTexture;
         if (tex == null) return;
         double uMin = tex.getSubIconU(bounds.minZ());
